﻿------------------------------------------------------------------------------------------
--Buff Frame Setup-------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")
local MODNAME = "buffs"
local BUFF = SN:NewModule(MODNAME, "AceEvent-3.0")

local timers = LibStub("LibFancyBar-1.0")

local UnitBuff = UnitBuff

local function KillBar(self, event, ...)
	local name, rank, icon, count, debuffType, duration, expiration, caster, canStealOrPurge, _ , spellId = UnitBuff("player", self:GetData("SN:arg5"))
	if not name then self:Stop() return end
end

local function buffUpdate(self, event, ...)
	if event == "PLAYER_ENTERING_WORLD" then
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	end

	--Update Buffs
	local buff
	local name, rank, icon, count, debuffType, duration, expiration, caster, canStealOrPurge, spellId, _

	local filter
	if SHOW_CASTABLE_BUFFS == "1" and canAssist then
		filter = "RAID"
	end
	
	local i = 1
	while true do
		name, rank, icon, count, debuffType, duration, expiration, caster, canStealOrPurge, _ , spellId = UnitBuff("player", i, filter)
		
		if not name then break end
		
		buff = self:Find("SN:arg5", name)
		
		if not buff then
			if not buff then
				buff = SN:CreateBar(self, spellId, (expiration - GetTime()), caster, UnitGUID("target"), name)
			end
				
			if duration == 0 and expiration == 0 then
				duration = 9999
				buff.FB_Duration:Hide()

				buff:RegisterUnitEvent("UNIT_AURA", "player")
				buff:SetScript("OnEvent", KillBar)
			end

			buff:SetDuration((expiration - GetTime()), duration)
			buff:Start()
		end
		i = i + 1
	end
end

function BUFF:OnInitialize()

	SN:RegisterModuleOptions(MODNAME, getOptions, L["Debuffs"])
	
	F.buffs = T:NewGroup(SN.data.profile.buffs.width, "Buff Frame", buffs, M.media.draghandle)
	F.buffs:SetSorting("SN:arg5")
	F.buffs:SetSpacing(0, SN.data.profile.buffs.yoffset)
	F.buffs:SetStartPoint(SN.data.profile.buffs.grow)
	F.buffs:SetPoint(unpack(SN.data.profile.frames.buffs))
	F.buffs:SetVisibleBars(SN.data.profile.buffs.visible)
	
	local color = NORMAL_FONT_COLOR

	--The mover frame text
	F.buffs.value = F.buffs:CreateFontString(nil, "OVERLAY")
	F.buffs.value:SetPoint("CENTER", F.buffs)
	F.buffs.value:SetFontObject(GameFontNormal)
	F.buffs.value:SetJustifyH("CENTER")
	F.buffs.value:SetTextColor(color.r, color.g, color.b)

	F.buffs.name = "Buffs"
	F.buffs.db = MODNAME

	if SN.data.profile.buffs.iconmode then
		F.buffs:SetIconMode(32 * SN.data.profile.buffs.iconscale, "BOTTOM", 0, 0)
		F.buffs:SetSpacing(SN.data.profile.buffs.fontsize / 2, SN.data.profile.buffs.fontsize + 3)
	end
	
	F.buffs:SetScript("OnEvent", function(self, event, ...)
		buffUpdate(self, event, ...)
	end)
end

function BUFF:OnEnable()
	F.buffs:Show()		
	--Register our events for the frame
	F.buffs:RegisterUnitEvent("UNIT_AURA", "player")
	F.buffs:RegisterEvent("PLAYER_ENTERING_WORLD")
	F.buffs:RegisterEvent("UPDATE_SHAPESHIFT_FORMS")
	F.buffs:RegisterEvent("UNIT_DISPLAYPOWER")
	F.buffs:RegisterEvent("UNIT_POWER_FREQUENT")
	F.buffs:RegisterEvent("PLAYER_LEVEL_UP")
	F.buffs:RegisterEvent("PLAYER_TALENT_UPDATE")
end

function BUFF:OnDisable()
	F.buffs:UnregisterAllEvents()
	F.buffs:Clear()
	F.buffs:Hide()
end

function BUFF:Lock()
	SN:LockFrame(F.buffs)
end

function BUFF:Unlock()
	SN:UnlockFrame(F.buffs)
end

function BUFF:Reset()
	local static = SN.DB.profile.frames
	local temp = SN.data.profile.frames
	F.buffs:ClearAllPoints()

	F.buffs:SetPoint(unpack(static.buffs))
	wipe(temp.buffs)
end

function BUFF:ApplySettings()
	F.buffs:ClearAllPoints()
	SN:EditBars(F.buffs.db)
end